org.apache.cxf.io

## Class AbstractWrappedOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.cxf.io.AbstractWrappedOutputStream

- All Implemented Interfaces:
    Closeable, Flushable, AutoCloseable
  Direct Known Subclasses:
    AbstractThresholdOutputStream

      public abstract class AbstractWrappedOutputStream
      extends OutputStream

  Provides a convenient hook onFirstWrite() for those needing to wrap an output stream.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `allowFlush`
    `protected OutputStream` | `wrappedStream`
    `protected boolean` | `written`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractWrappedOutputStream()`
    `protected` | `AbstractWrappedOutputStream(OutputStream os)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `allowFlush(boolean b)`
    `void` | `close()`
    `void` | `flush()`
    `protected void` | `onFirstWrite()`
    `void` | `write(byte[] b)`
    `void` | `write(byte[] b, int off, int len)`
    `void` | `write(int b)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### wrappedStream

          protected OutputStream wrappedStream

    - #### written

          protected boolean written

    - #### allowFlush

          protected boolean allowFlush

  - ### Constructor Detail

    - #### AbstractWrappedOutputStream

          protected AbstractWrappedOutputStream()

    - #### AbstractWrappedOutputStream

          protected AbstractWrappedOutputStream(OutputStream os)

  - ### Method Detail

    - #### write

          public void write(byte[] b,
                            int off,
                            int len)
                     throws IOException

      Overrides:
        `write` in class `OutputStream`
      Throws:
        `IOException`

    - #### onFirstWrite

          protected void onFirstWrite()
                               throws IOException

      Throws:
        `IOException`

    - #### write

          public void write(byte[] b)
                     throws IOException

      Overrides:
        `write` in class `OutputStream`
      Throws:
        `IOException`

    - #### write

          public void write(int b)
                     throws IOException

      Specified by:
        `write` in class `OutputStream`
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `OutputStream`
      Throws:
        `IOException`

    - #### flush

          public void flush()
                     throws IOException

      Specified by:
        `flush` in interface `Flushable`
      Overrides:
        `flush` in class `OutputStream`
      Throws:
        `IOException`

    - #### allowFlush

          public void allowFlush(boolean b)

Apache CXF